/*
 * Copyright (C) 2022 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.server.art.model;

import android.annotation.NonNull;
import android.annotation.Nullable;

import com.android.internal.annotations.Immutable;

/**
 * Detailed information about a dex file.
 *
 * @hide
 */
@Immutable
public interface DetailedDexInfo {
    /** The path to the dex file. */
    @NonNull String dexPath();

    /**
     * A string describing the structure of the class loader that the dex file is loaded with, or
     * null if the class loader context is invalid.
     */
    @Nullable String classLoaderContext();
}
